' @(#)77  1.3  src/hc/client/collectors/C/vbs/GetGPOData.vbs, hc.collectors.win, scmweb, 091208a  12/8/09  11:38:55
'
' IBM Security Compliance Manager
' 5724-F82
' (C) IBM, 2006.
' All Rights Reserved
' Licensed Materials - Property of IBM
'
' US Government Users Restricted Rights - Use, duplication or
' disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
'
'-------------------------------------------------------------------------
'This script queries WMI repository from Vista client from namespace:
'	Root\RSOP\Computer
'It queries the following RSOP Objects:
'	RSOP_GPO
'	RSOP_RegistryPolicySetting
'Parameters:
'	registry param - value of registryKey used in the WMI query
'	use param - indicates if the query use equal registryKey value / like 
'	registryKey value (E/L)
'	displayGPOID param - includes in the script output a line containing 
'the name of GPO (Y/N) 
'-------------------------------------------------------------------------
'Option Explicit ' force variable declaration
On Error Resume Next
Err.Clear
'-------------------------------------------------------------------------
' Constants
'-------------------------------------------------------------------------
'*************************************************************************
'Registry value types
'*************************************************************************
'No defined value type.
Const REG_NONE = "0"
'A null-terminated string. This will be either a Unicode or an ANSI string, depending on whether 
'you use the Unicode or ANSI functions.
Const REG_SZ = "1"
'A null-terminated string that contains unexpanded references to environment variables (for example, "%PATH%"). 
'It will be a Unicode or ANSI string depending on whether you use the Unicode or ANSI functions. 
'To expand the environment variable references, use the ExpandEnvironmentStrings function.
Const REG_EXPAND_SZ = "2" 
'Binary data in any form.
Const REG_BINARY = "3" 
'A 32-bit number.
Const REG_DWORD = "4"
'A 32-bit number in little-endian format
Const REG_DWORD_LITTLE_ENDIAN = "4"
'A 32-bit number in big-endian format.
Const REG_DWORD_BIG_ENDIAN = "5" 
'A null-terminated Unicode string that contains the target path of a symbolic link that was created 
'by calling the RegCreateKeyEx function with REG_OPTION_CREATE_LINK.
Const REG_LINK = "6"
'A sequence of null-terminated strings, terminated by an empty string (\0).
'eg String1\0String2\0String3\0LastString\0\0
Const REG_MULTI_SZ = "7"
'A 64-bit number.
Const REG_QWORD = "11"
'*************************************************************************
'Other constants
'*************************************************************************
Const FL_FORCE_CREATE_NAMESPACE = 4
Const VALUE_NONE="<NONE>"
Const VALUE_UNKNOWN="<UNKNOWN>"
Const Sep="||"
Const PREFIX = "GPOID"
Const GPOID_HEADER="[GPO]"
Const SepVal = "="
Const DEBUG_ON = false
'-------------------------------------------------------------------------
' Function: registryValue
'-------------------------------------------------------------------------
Private Function registryValue (regValue,regType)
	'WScript.Echo "Fnc registryValue/regType=" & CStr(regType)
	'WScript.Echo "Fnc registryValue/REG_NONE=" & CStr(REG_NONE)
	registryValue=""
	Select Case CStr(regType)
		Case  REG_NONE
			registryValue = VALUE_NONE
		Case REG_DWORD   
			lenArray=UBound(regValue)
			'Wscript.Echo "lenArray=" & CStr(lenArray)
			If lenArray>0 THEN
				For i = 0 To lenArray
					valElement=regValue(lenArray-i)
					'Wscript.Echo "valElement=" & CStr(valElement)
					registryValue = registryValue & CStr(valElement)
				Next
			End If
			registryValue=CStr(Hex(CLng(registryValue)))
		Case REG_SZ
			lenArray=UBound(regValue)
			'Wscript.Echo "lenArray=" & CStr(lenArray)
			If lenArray>0 THEN
				For i = 0 To lenArray
					valElement=regValue(i)
					'Wscript.Echo "valElement=" & CStr(valElement)
					valueChar = ""
					If CInt(valElement)>0 THEN
						valueChar=CStr(Chr(valElement))
					End If
					registryValue = registryValue & valueChar
				Next
			End If
		Case Else  
			registryValue = VALUE_UNKNOWN
	End Select
End Function 

'-------------------------------------------------------------------------
' Function: registryPolicySetting
'-------------------------------------------------------------------------
Private Function registryPolicySetting (queryRegistry,queryRegGpo)
	Set colItems = rsopProv.ExecQuery(queryRegistry)
	If (Err.number <> 0 AND Err.number <> 424) Then
		WScript.StdErr.Write "[ERROR] Error executing WMI query " & queryRegistry & " Err number=" & Err.number & " Err description=" & Err.description
		WScript.Quit(-1)
	End If
	if DEBUG_ON = true then
		WScript.Echo "#" & "queryRegistry=" & queryRegistry
	end	if
	WScript.Echo "[" & queryRegGpo & "]"
	For Each objItem in colItems
		valueObjType = objItem.valueType
		'If skipNone = false Or valueObjType <> CInt(REZ_NONE) Then
		if DEBUG_ON = true then
			WScript.Echo "#" & String(100, "=")
			Wscript.Echo "#" & "Policy Item Name: " & objItem.name
			WScript.Echo "#" & String(100, "=")
			Wscript.Echo "#" & "Policy Item GPOID: " & objItem.GPOID
			Wscript.Echo "#" & "Policy Item precedence: " & objItem.precedence
			Wscript.Echo "#" & "Policy Item id: " & objItem.id
			Wscript.Echo "#" & "Policy Item SOMID: " & objItem.SOMID
			Wscript.Echo "#" & "Policy Item regisrtyKey: " & objItem.registryKey
		end if	
		valueObjArray = objItem.value
		registryValueObj=registryValue(valueObjArray,valueObjType)
		WScript.Echo objItem.registryKey & Sep & objItem.valueName & SepVal &  registryValueObj 
		if DEBUG_ON = true then
			Wscript.Echo "#" & "Policy Item valueName: " & objItem.valueName
			Wscript.Echo "#" & "Policy Item valueType: " & valueObjType
			Wscript.Echo "#" & "Policy Item value: " & registryValueObj
		End if	
	Next
	if colItems.count > 0 then
		if DEBUG_ON = true then
			WScript.Echo "#" & String(100, "=")
		end if	
	end if
End Function

'-------------------------------------------------------------------------
' Main
'-------------------------------------------------------------------------
 WScript.Echo " "
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Get vbscript input parameters
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

'WScript.Echo WScript.Arguments.count
if WScript.Arguments.count > 0 then
	regkey = WScript.Arguments(0)
else
'default
  regkey="SOFTWARE\\Policies\\Microsoft\\WindowsFirewall\\"
end if
if DEBUG_ON = true then
	WScript.Echo "#" & "regkey=" & regkey
end if

'Use registry location as a "like"(L) parameter versus a "="(E) parameter 
if WScript.Arguments.count > 1 then
	use = WScript.Arguments(1)
else
'default
	use = "E"
end if 
if DEBUG_ON = true then
	WScript.Echo "#" & "use=" & use
end if	

'Display GPOID header Y / N
if WScript.Arguments.count > 2 then
	displayGPOID = WScript.Arguments(2)
else
	displayGPOID = "Y"	
end if 
if DEBUG_ON = true then
	WScript.Echo "#" & "displayGPOID=" & displayGPOID
end if	

'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Connect to WMI registry of 
' the current computer
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
strComputer = "."
Set locator = CreateObject("WbemScripting.SWbemLocator")
Set rsopProv = locator.ConnectServer _
    (strComputer, "root\rsop" & "\Computer", null, null, null, null, 0 , null)

If (Err.number <> 0) Then
    WScript.StdErr.Write "[ERROR] Error connecting to WMI " & Err.number & " " & Err.description
	WScript.Quit(-1)
End If

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Get the list of global policies
' that affects the current computer
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
queryRegBaseEqual = "select * from RSOP_RegistryPolicySetting where registryKey = " & Chr(34)
queryRegBaseLike = "select * from RSOP_RegistryPolicySetting where registryKey like " & Chr(34)
queryRegGpoBase =  Chr(34) & " and GPOID=" & Chr(34)
queryRegGpo = "LocalGPO"
queryPrec = " and precedence=1 and valueType != 0"
Set colItemsGPO = rsopProv.ExecQuery("select * from RSOP_GPO")
If (Err.number <> 0) Then
    WScript.StdErr.Write "[ERROR] Error executing WMI query from RSOP_GPO Err number=" & Err.number & " Err description=" & Err.description
	WScript.Quit(-1)
End If
size=colItemsGPO.count
if DEBUG_ON = true then
	WScript.Echo "#" & "Number of GPOs=" & size
end if	
if displayGPOID = "Y" then
	WScript.Echo GPOID_HEADER
end if	
if size > 0 THEN
	count=0
	Dim d    
	Set d = CreateObject("Scripting.Dictionary")
	For Each objItemGPO in colItemsGPO
		if DEBUG_ON = true then
			WScript.Echo "#" & " "
			WScript.Echo "#" & String(100, "*")
			WScript.Echo "#" & "GPO Name: " & objItemGPO.name
			WScript.Echo "#" & String(100, "*")
			WScript.Echo "#" & "GPO enabled: " & objItemGPO.enabled
			WScript.Echo "#" & "GPO fileSystemPath: " & objItemGPO.fileSystemPath
			WScript.Echo "#" & "GPO guidName: " & objItemGPO.guidName
		end if	
		if objItemGPO.enabled then
			queryRegGpo = objItemGPO.id
			count=count + 1
			if displayGPOID = "Y" then
				WScript.Echo PREFIX & Cstr(count)& "=" & queryRegGpo 
			end if	
			if DEBUG_ON = true then
				WScript.Echo "#" & "GPO id: " & objItemGPO.id
			end if
			
			d.add CStr(count), objItemGPO.id
		end if	
	NEXT
	ditems=d.items()
	size=ditems.count
	if size > 0 then
	
		For Each item in ditems
			if DEBUG_ON = true then
				WScript.Echo "#" & "item=" & item
			end if	
			if use="L" then
				queryReg = queryRegBaseLike & regKey & "%" & queryRegGpoBase & item & Chr(34) & queryPrec
				'queryReg = queryRegBaseLike & regKey & "%" & queryRegGpoBase & item & Chr(34)
			else
				queryReg = queryRegBaseEqual & regKey & queryRegGpoBase & item & Chr(34) & queryPrec
				'queryReg = queryRegBaseEqual & regKey & queryRegGpoBase & item & Chr(34) 
			end if
			if DEBUG_ON = true then
				WScript.Echo "#" & String(100, ".")
				WScript.Echo "#" & "queryReg=" & queryReg
				WScript.Echo "#" & String(100, ".")
			end if	
			registryPolicySetting queryReg, item
		NEXT
		if DEBUG_ON = true then
			WScript.Echo "#" & String(100, "*")
		end if
	end if		
end if

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Get the data collected
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
 WScript.Echo " "
provider.RsopDeleteSession namespaceLocation, hResult
