' @(#)58    1.2  src/hc/client/collectors/C/vbs/oldest_event.vbs, hc.collectors.win, scmweb, 080912a  11/30/07  04:07:06
'
' IBM Security Compliance Manager
' 5724-F82
' (C) IBM, 2006.
' All Rights Reserved
' Licensed Materials - Property of IBM
'
' US Government Users Restricted Rights - Use, duplication or
' disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
'
'Option Explicit				' force variable declaration
'On Error Resume Next

Const wbemFlagReturnImmediately = &h10
Const wbemFlagForwardOnly       = &h20

Dim osVersion       ' OS version (6 - Vista family)
Dim query						'query variable
Dim wmiService					'WMI object
Dim wmiFlags					'WMI execution falgs
Dim eventlogFiles				'event logs to iterate over
Dim eventlog  	 				'single event logs
wmiFlags = wbemFlagReturnImmediately + wbemFlagForwardOnly

Dim strComputer
strComputer = "."

Set wmiService = GetObject("winmgmts:" & "{impersonationLevel=impersonate,(Security)}!\\" & strComputer & "\root\cimv2")

If (Err.number <> 0) Then
	If IsNull(wmiService)  Then
		WScript.StdErr.Write "[ERROR] WMI service not available."
	Else
        WScript.StdErr.Write "[ERROR] " & Err.description
    End If
	WScript.Quit(-1)
End If

' get OS version to check if we are running on Vista or later
Set colOSes = wmiService.ExecQuery("Select * from Win32_OperatingSystem")
For Each objOS in colOSes
  osVersion = Left(objOS.Version, 1)
  Exit For
Next

query = "SELECT OverWritePolicy, OverwriteOutDated, NumberOfRecords, LogfileName FROM Win32_NTEventlogFile"
Set eventlogFiles = wmiService.ExecQuery(query, "WQL", wmiFlags)

For Each eventLog In eventlogFiles
	Dim logFileName
    Dim logFileRecordCount			'total number of records gathered from log file
	Dim logFileHighestRecordIndex	'the recordNumber of the last logEvent (the highest one)
	Dim logFileRecordIndex			'index of the oldes event from log
    Dim oldestEventTimeWritten		'the time when the first event has been logged
    Dim logFileEvents				'events stored in single log
    Dim singleEvent					'single event from log
	Dim eventExists					'indicate if log contains events
	Dim logOverwriteOutdatedFlag	'flag indicating overwrite policy (eventLog.OverwriteOutDated)
	
    logFileName = eventLog.LogfileName
    logFileRecordCount = eventLog.NumberOfRecords
	logOverwriteOutdatedFlag = eventLog.OverwriteOutDated

	query = "Select RecordNumber from Win32_NTLogEvent Where Logfile = '" & logFileName & "'"
    Set logFileEvents = wmiService.ExecQuery(query, "WQL", wmiFlags)
	For Each singleEvent In logFileEvents
		logFileHighestRecordIndex = singleEvent.RecordNumber
        Exit For
    Next
	
	'Determining what is the record Number of the first event logged
    logFileRecordIndex = logFileHighestRecordIndex - logFileRecordCount + 1
    If (osVersion = 6) Then
      ' on Windows Vista family log events are already sorted ascending,
      ' so the first record is the oldest one
      logFileRecordIndex = logFileHighestRecordIndex
    End If
	logFileEvents = NULL
    query = "SELECT TimeWritten FROM Win32_NTLogEvent WHERE (Logfile ='" & logFileName & "' AND RecordNumber=" & logFileRecordIndex & ")"
	Set logFileEvents = wmiService.ExecQuery(query, "WQL", wmiFlags)
	 
	singleEvent = NULL
	oldestEventTimeWritten = NULL
    eventExists = FALSE
    For Each singleEvent In logFileEvents
		eventExists = TRUE
        oldestEventTimeWritten = singleEvent.TimeWritten
        Exit For
    Next

    If (Err.number <> 0) Then
        WScript.StdErr.Write "[ERROR] " & Err.description
        Err.clear
    End If

    If (eventExists = FALSE) Then
		oldestEventTimeWritten = ""
    End If     
	
    WScript.Echo "[eventlog]"
	WScript.Echo "logFileName       = " & logFileName
    WScript.Echo "numberOfRecords   = " & logFileRecordCount
    WScript.Echo "overwriteOutDated = " & logOverwriteOutdatedFlag
    'WScript.Echo "overwritePolicy   = " & eventLog.OverWritePolicy 
	WScript.Echo "oldestEventTime   = " & oldestEventTimeWritten

    'OverwriteOutDated: 0 			- Any entry can be overwritten when necessary.
    'OverwriteOutDated: 1..365 	    - Events that have been in the log file for one year (365 days) or less can be overwritten.
    'OverwriteOutDated: 4294967295  - Nothing can be ever be overwritten.

    WScript.Echo 
Next

WScript.Quit(0)



