' Licensed Materials - Property of IBM
' Copyright IBM Corp. 2003, 2005, 2006. All Rights Reserved
' OCO Source Materials
' 5724-F82
' Version 2.0
'
Offline = False
updatesFilters = 0
isAssigned = 0
Dim Args
Set Args = Wscript.Arguments

' Lets check the Windows Update Agent version:
wuaSupportedVersion = false
On Error Resume Next
Set wuaInfo = CreateObject("Microsoft.Update.AgentInfo")
If Err.Number = 0 Then
  wuaVersion = 0
  wuaVersion = wuaInfo.GetInfo("ApiMajorVersion")
  If (wuaVersion >= 3) Then
    wuaSupportedVersion = true
  End If
End If
On Error Goto 0

' Ooops:
If wuaSupportedVersion = false Then
  Set objStdErr = WScript.StdErr
  objStdErr.Write("Error: Not supported WUA version")
  WScript.Quit(1)
End If

' Lets rock:
Set UpdateSession = Wscript.CreateObject("Microsoft.Update.Session")
Set UpdateServiceManager = Wscript.CreateObject("Microsoft.Update.ServiceManager")

updatesFilters = Args(0)
isAssigned = Args(1)

If Args.Count = 3 Then
   'Offline scanning mode with wsusscan.cab... must specifiy full path to cab
   Offline = True
   Set UpdateService = UpdateServiceManager.AddScanPackageService("Offline Sync Service", Args(2))
End If

Set UpdateSearcher = UpdateSession.CreateUpdateSearcher()

UpdateSearcher.IncludePotentiallySupersededUpdates = True

If Offline = True Then
   'commented to fix compatibility with VMWare
   'UpdateSearcher.Online = False
   UpdateSearcher.ServiceID = UpdateService.ServiceID
   UpdateSearcher.ServerSelection = 3 'ssOther
End IF

Set SearchResult = UpdateSearcher.Search("Type='Software' and IsInstalled=0 and IsAssigned=" & isAssigned)

Set Updates = SearchResult.Updates

If searchResult.Updates.Count = 0 Then
    WScript.Echo "Complied"
    WScript.Quit
End If

ID_SPACK = "68c5b0a3-d1a6-4553-ae49-01d3a7827828" 'Name="Service Packs"
ID_UPDAT = "cd5ffd1e-e932-4e3a-bf74-18bf0b1bbd83" 'Name="Updates"
ID_CUPDT = "e6cf1350-c01b-414d-a61f-263d14d133b4" 'Name="Critical Updates"
ID_FEATP = "b54e7d24-7add-428f-8b75-90a396fa584f" 'Name="Feature Packs"
CT_UPDCL = "UpdateClassification"

'collection for IDs of superseded updates
Set superseded = CreateObject("Microsoft.Update.StringColl")

If updatesFilters = 0 Then
For I = 0 to searchResult.Updates.Count-1
    BullentinID = ""
    Set update = searchResult.Updates.Item(I)

    Set BulletinIDs = update.SecurityBulletinIDs
    For J = 0 to BulletinIDs.Count-1
      If J=1 Then Exit For
      BullentinID = BulletinIDs.Item(J)
    Next
    
    Title = update.Title
    Seve = update.MsrcSeverity
    ' IZ42205
    ' If no "(KB??????)" at the end of title, add such an info.
    ' Condition oposite to condition in Java code not to affect correct forms.
    If InStrRev(Title, "(KB") = 0 Or Right(Title, 1) <> ")" Then
    	Set KBArticleIDs = update.KBArticleIDs
    	For J = 0 to KBArticleIDs.Count-1
      		Title = Title & " (KB" & KBArticleIDs.Item(J) & ")"
    	Next
    End If
    
 			catID = ""
			 For each category in SearchResult.Updates.Item(i).Categories
			    	catID = category.Type
				exit for
			next
			            
			descrStep11 = Replace(update.Description, vbCrLf, "")
            descrStep12 = Replace(descrStep11, vbCr, "")
            descrStep13 = Replace(descrStep12, vbLf, "")         
			WScript.Echo BullentinID & "|" & descrStep13 & "|" & Title & "{" & catID & "}<" & Seve & ">"
   WScript.Echo ""
Next
End If

If updatesFilters = 1 Then
For i = 0 to SearchResult.Updates.Count -1

    '*** PG: see, if update is service pack
    '*** PG: detection of services packs should be done by category-id, rather than by category name
    is_servicepack = false
    For each category in SearchResult.Updates.Item(i).Categories
		if category.Type = CT_UPDCL AND category.CategoryID = ID_SPACK then
	    	is_servicepack = true
			exit for
		end if
    next

    if SearchResult.Updates.Item(i).SupersededUpdateIDs.count > 0 then
        if not is_servicepack then
            '*** PG: collect all superseded updates, not superseded by service packs
		    For each ID in SearchResult.Updates.Item(i).SupersededUpdateIDs
	    	    For y = 0 to SearchResult.Updates.Count -1
			    	if SearchResult.Updates.Item(y).Identity.UpdateID = ID then
						superseded.add ID
                    end if
                Next
            Next
        else
            '*** PG: collect all service packs, superseded by another service pack
		    For each ID in SearchResult.Updates.Item(i).SupersededUpdateIDs
				For y = 0 to SearchResult.Updates.Count -1
				    sub_servicepack = false
			    	For each Category in SearchResult.Updates.Item(Y).Categories
						if Category.Type = CT_UPDCL AND Category.CategoryID = ID_SPACK then
	    				    sub_servicepack = true
							exit for
						end if
				    Next
				    if sub_servicepack and ( SearchResult.Updates.Item(y).Identity.UpdateID = ID ) then
	    				superseded.add id
		    		end if
            	Next
            Next
		end if
    end if
next

count=0
For i = 0 to SearchResult.Updates.Count -1
    is_security = true
    for each Category in SearchResult.Updates.Item(i).Categories
		if Category.type = CT_UPDCL and _
	   		(Category.CategoryID = ID_UPDAT or Category.CategoryID = ID_CUPDT or Category.CategoryID = ID_FEATP) then
	    	is_security = false
			exit for
		end if
    next
	if is_security then 
		is_superseded = false
		for each ID in superseded
			if SearchResult.Updates.Item(i).Identity.UpdateID = ID then
				is_superseded = true
				exit for
			end if
		next
		if not is_superseded then 
		
			count=count+1

			Set update = searchResult.Updates.Item(i)

			BullentinID = ""
			Set BulletinIDs = update.SecurityBulletinIDs
			if BulletinIDs.Count > 0 then
				BullentinID = BulletinIDs.Item(0)
			end if
    
			Title = update.Title
    
    			Seve = update.MsrcSeverity

			' IZ42205
			' If no "(KB??????)" at the end of title, add such an info.
			' Condition oposite to condition in Java code does not affect correct forms.
			If InStrRev(Title, "(KB") = 0 Or Right(Title, 1) <> ")" Then
				Set KBArticleIDs = update.KBArticleIDs
				For j= 0 to KBArticleIDs.Count-1
					Title = Title & " (KB" & KBArticleIDs.Item(j) & ")"
				Next
			End If

			catID = ""
			 For each category in SearchResult.Updates.Item(i).Categories
			    	catID = category.Type
				exit for
			next
			
			descrStep21 = Replace(update.Description, vbCrLf, "")
            descrStep22 = Replace(descrStep21, vbCr, "")
            descrStep23 = Replace(descrStep22, vbLf, "") 
			WScript.Echo BullentinID & "|" & descrStep23 & "|" & Title & "{" & catID & "}<" & Seve & ">"
			WScript.Echo ""
		end if	
	end if	
Next
End If

If updatesFilters = 2 Then
For i = 0 to SearchResult.Updates.Count -1

    '*** PG: see, if update is service pack
    '*** PG: detection of services packs should be done by category-id, rather than by category name
    is_servicepack = false
    For each category in SearchResult.Updates.Item(i).Categories
		if category.Type = CT_UPDCL AND category.CategoryID = ID_SPACK then
	    	is_servicepack = true
			exit for
		end if
    next

    if SearchResult.Updates.Item(i).SupersededUpdateIDs.count > 0 then
        if not is_servicepack then
            '*** PG: collect all superseded updates, not superseded by service packs
		    For each ID in SearchResult.Updates.Item(i).SupersededUpdateIDs
	    	    For y = 0 to SearchResult.Updates.Count -1
			    	if SearchResult.Updates.Item(y).Identity.UpdateID = ID then
						superseded.add ID
                    end if
                Next
            Next
        else
            '*** PG: collect all service packs, superseded by another service pack
		    For each ID in SearchResult.Updates.Item(i).SupersededUpdateIDs
				For y = 0 to SearchResult.Updates.Count -1
				    sub_servicepack = false
			    	For each Category in SearchResult.Updates.Item(Y).Categories
						if Category.Type = CT_UPDCL AND Category.CategoryID = ID_SPACK then
	    				    sub_servicepack = true
							exit for
						end if
				    Next
				    if sub_servicepack and ( SearchResult.Updates.Item(y).Identity.UpdateID = ID ) then
	    				superseded.add id
		    		end if
            	Next
            Next
		end if
    end if
next

count=0
For i = 0 to SearchResult.Updates.Count -1
    is_security = true
    for each Category in SearchResult.Updates.Item(i).Categories
		if Category.type = CT_UPDCL and _
	   		(Category.CategoryID = ID_UPDAT or Category.CategoryID = ID_CUPDT or Category.CategoryID = ID_FEATP) then
	    	is_security = false
			exit for
		end if
    next
	if 1 = 1 then 
		is_superseded = false
		for each ID in superseded
			if SearchResult.Updates.Item(i).Identity.UpdateID = ID then
				is_superseded = true
				exit for
			end if
		next
		if not is_superseded then 
		
			count=count+1

			Set update = searchResult.Updates.Item(i)

			BullentinID = ""
			Set BulletinIDs = update.SecurityBulletinIDs
			if BulletinIDs.Count > 0 then
				BullentinID = BulletinIDs.Item(0)
			end if
    
			Title = update.Title
    
    			Seve = update.MsrcSeverity

			' IZ42205
			' If no "(KB??????)" at the end of title, add such an info.
			' Condition oposite to condition in Java code does not affect correct forms.
			If InStrRev(Title, "(KB") = 0 Or Right(Title, 1) <> ")" Then
				Set KBArticleIDs = update.KBArticleIDs
				For j= 0 to KBArticleIDs.Count-1
					Title = Title & " (KB" & KBArticleIDs.Item(j) & ")"
				Next
			End If

			catID = ""
			 For each category in SearchResult.Updates.Item(i).Categories
			    	catID = category.Type
				exit for
			next
			
			descrStep31 = Replace(update.Description, vbCrLf, "")
            descrStep32 = Replace(descrStep31, vbCr, "")
            descrStep33 = Replace(descrStep32, vbLf, "") 
			WScript.Echo BullentinID & "|" & descrStep33 & "|" & Title & "{" & catID & "}<" & Seve & ">"
			WScript.Echo ""
		end if	
	end if	
Next
End If

WScript.Echo "Done " & count
WScript.Quit
