' @(#)70  1.3  src/hc/client/collectors/C/vbs/sid.vbs, hc.collectors.win, scmweb, 100923a  9/21/10  12:23:09
'
' IBM Security Compliance Manager
' 5724-F82
' (C) IBM, 2005.
' All Rights Reserved
' Licensed Materials - Property of IBM
'
' US Government Users Restricted Rights - Use, duplication or
' disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
'
'------------------------------------------------------------
On Error Resume Next

machineSid = getMachineSid
domainSid  = getDomainSid

WScript.Echo "[SID]"
WScript.Echo "machine = " & machineSid
WScript.Echo "domain  = " & domainSid

WScript.Quit(0)
'------------------------------------------------------------
' Returns machine SID from Windows registry
'------------------------------------------------------------
Function getMachineSid
	Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
	Set colAccounts = objWMIService.ExecQuery _
	    ("Select * From Win32_UserAccount Where LocalAccount=True")
	
	getMachineSid = ""
	For Each objAccount in colAccounts
	    If Left (objAccount.SID, 6) = "S-1-5-" and Right(objAccount.SID, 4) = "-500" Then
	        getMachineSid = Left (objAccount.SID,len(objAccount.SID)-4)     
	    End If
	Next

End Function
'------------------------------------------------------------
' Returns domain SID, if host belongs to domain, or empty
' string otherwise
'------------------------------------------------------------
Function getDomainSid
	Set root = GetObject("LDAP://rootDSE")
	If Not IsNull(root) Then
		Set domain = GetObject("LDAP://" & root.Get("defaultNamingContext") )
		domain.GetInfo
		getDomainSid = ConvertSidToString(domain.Get("objectSid"))
	Else
		getDomainSid = ""
	End If
	
End Function


'------------------------------------------------------------
' Converts SID from binary/variant array into string
'------------------------------------------------------------
' Pictorially the structure of an SID is as follows: 
'   1 1 1 1 1 1 
'   5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0 
' +---------------------------------+ 
' | SubAuthCount   |Re(SBZ)|  Rev   | 
' +---------------------------------+ 
' |     IdentifierAuthority[0]      | 
' +---------------------------------+ 
' |     IdentifierAuthority[1]      | 
' +---------------------------------+ 
' |     IdentifierAuthority[2]      | 
' +---------------------------------+ 
' |                                 | 
' + -  -  -  SubAuthority[]  -  - - + 
' |                                 | 
' +---------------------------------+
Function ConvertSidToString(sid) 

    revision = GetSidByte(sid, 1)
    subAuthCount = GetSidByte(sid, 2)

    Dim sidauth(5)
    For i = 0 To 5
        sidauth(i) = GetSidByte(sid, 3+i)
    Next
    If ( (sidauth(0) <> 0) OR (sidauth(1) <> 0) ) Then
        authority = "0x"
        For i = 0 To 5 
            authority = authority & Right("0" & Hex(Ascb(sidauth(i))), 1)
        Next       
       
    Else
        authority = CLng(sidauth(2)*(256^3) + sidauth(3)*(256^3) _
                         + sidauth(4)*(256^1) + sidauth(5))
    End If

    strSid = "S-" & revision & "-" & authority 
    c = 9
    For i = 1 To subAuthCount
        auth = 0
        For j = 0 To 3
            auth = auth + CLng(GetSidByte(sid, c))*(256^j)
            c = c + 1
        Next
        strSid = strSid & "-" & cstr(auth)
    Next
    ConvertSidToString = strSid
End Function


'------------------------------------------------------------
' Returns single byte/variant from sid object. Used to 
' handle two input SID formats: registry and active directory
'------------------------------------------------------------
Function GetSidByte(sid, index)
	If TypeName(sid) = "Byte()" Then
		GetSidByte = Ascb(Midb(sid, index, 1))
	Else
		GetSidByte = sid(index)
	End If
End Function

'------------------------------------------------------------