' @(#)69  1.5  src/hc/client/collectors/C/vbs/windowsfw.vbs, hc.collectors.win, scmweb, 091110a  11/10/09  07:41:52
' IBM Security Compliance Manager
' 5724-F82                       
' (C) IBM, 2005.                 
' All Rights Reserved            
' Licensed Materials - Property of IBM 
'
' US Government Users Restricted Rights - Use, duplication or 
' disclosure restricted by GSA ADP Schedule Contract with IBM Corp.

On Error Resume Next
Err.Clear

Dim strComputer
Dim cmdStr
Dim objWMIService
Dim colListOfServices
Dim objItem
Dim property
Dim sh

Dim installPath
Dim installDate
Dim version
Dim firewallEnabled
Dim startMode
Dim serviceStarted
Dim serviceStatus

' ----------------------------------------------------
Function isFirewallEnabled
	On Error Resume Next

	Set objFirewall = CreateObject("HNetCfg.FwMgr")
	If (Err.number <> 0) Then
  		If IsNull(objFirewall)  Then
	    	isFirewallEnabled="[ERROR] HNetCfg.FwMgr not available."
  		Else
	    	isFirewallEnabled="[ERROR] " & "HNetCfg.FwMgr " & Err.Number & " - " & Err.description
  		End If
  		Err.clear
  		Exit Function
	End If

	Set objPolicy0 = objFirewall.LocalPolicy
	If (Err.number <> 0) Then
  		If IsNull(objPolicy0)  Then
    		isFirewallEnabled="[ERROR] Policy at HNetCfg.FwMgr not available."
  		Else
    		isFirewallEnabled="[ERROR] " & "Policy " & Err.Number & " - " & Err.description
  		End If
  		Err.clear
  		Exit Function
	End If

	Set objPolicy = objPolicy0.CurrentProfile
	If (Err.number <> 0) Then
  		If IsNull(objPolicy)  Then
    		isFirewallEnabled="[ERROR] CurrentProfile at HNetCfg.FwMgr not available."
  		Else
    		isFirewallEnabled="[ERROR] " & "CurrentProfile " & Err.Number & " - " & Err.description
  		End If
  		Err.clear
  		Exit Function
	End If
	
	isFirewallEnabled = 1
	if (objPolicy.FirewallEnabled = FALSE) Then
		isFirewallEnabled = 0
	End If
	
End Function
' ----------------------------------------------------

if Wscript.Arguments.Named.Exists("computer") then
  strComputer= WScript.Arguments.Named.Item("computer")
else
  strComputer = "."
end if

' configurable name of the firewall service
' for Windows 2k and XP it is SharedAccess
' for Windows Vista it is MpsSvc
Dim serviceName
Set args = Wscript.Arguments
If args.Count > 1 Then
  serviceName = args(1)
End If
If args.Count = 1 Then
  serviceName = args(0)
End If
If args.Count = 0 Then
  serviceName = "SharedAccess"
End If

cmdStr= "winmgmts:{impersonationLevel=impersonate}!\\" & strComputer & "\root\cimv2"

Set objWMIService = GetObject(cmdStr)

serviceStarted="False"

Set colListOfServices = objWMIService.ExecQuery( "Select * from Win32_Service where name='" & serviceName & "'")
 For Each objItem in colListOfServices
    for each property in objItem.Properties_
      if not IsNull(property) then
        if property.name = "Started" then
          serviceStarted = property.value
        end if
        if property.name = "StartMode" then
          startMode = property.value
        end if
        if property.name = "State" then
          state = property.value
        end if
        if property.name = "Status" then
          serviceStatus = property.value
        end if
     end if
   Next
 Next

set sh = Wscript.CreateObject("WScript.Shell")

installPath=sh.RegRead("HKLM\SYSTEM\CurrentControlSet\Services\" & serviceName & "\ImagePath" )
if not Err.number = 0 then
   installPath="[ERROR:" & Err.description & "]"
   Err.clear
end if

version = sh.RegRead("HKLM\SOFTWARE\Microsoft\Windows NT\CurrentVersion\CSDVersion" )
if not Err.number = 0 then
   version="[ERROR:" & Err.description & "]"
   Err.clear
end if

firewallEnabled = isFirewallEnabled

if not IsNull(installPath) then
  Wscript.echo "[INSTALLED]"
else
  Wscript.echo "[NOT INSTALLED]"
end if

Wscript.echo "enabled=" & firewallEnabled
Wscript.echo "installPath=" & installPath
Wscript.echo "installDate=" & installDate
Wscript.echo "version=" & version
Wscript.echo "startMode=" & startMode
Wscript.echo "serviceStatus=" & serviceStatus
Wscript.echo "serviceState=" & state
Wscript.echo "serviceStarted=" & serviceStarted  
